<template>
    <div>
        <section class="hero" style="max-height: 100vh">
            <div class="">
                <div class="container has-text-centered">
                    <div class="column is-6 is-offset-3">
                        <h3 class="title has-text-grey">{{ signlogin }}</h3>
                        <p class="subtitle has-text-grey is-lowercase">Please {{ signlogin }} to proceed.</p>
                        <div class="box">
                                <div v-if="signUp" class="field">
                                  <div class="control has-icons-left">
                                    <input class="input is-medium" type="text" :class="{ 'is-danger': empty }" placeholder="Text input" v-model="name">
                                    <span class="icon is-small is-left">
                                      <i class="fa fa-user"></i>
                                    </span>
                                  </div>
                                </div>
                                <div class="field">
                                  <div class="control has-icons-left">
                                    <input class="input is-medium" type="email" placeholder="Text input" v-model="email">
                                    <span class="icon is-small is-left">
                                      <i class="fa fa-envelope"></i>
                                    </span>
                                  </div>
                                </div>

                                <div class="field">
                                    <div class="control">
                                        <input class="input is-medium" :class="{ 'is-danger': mismatch }" type="password" placeholder="Your Password" v-model="password">
                                    </div>
                                </div>
                                <div v-if="signUp" class="field">
                                    <div class="control">
                                        <input class="input is-medium" :class="{ 'is-danger': mismatch }" type="password" placeholder="Confirm Password" v-model="cpassword">
                                    </div>
                                </div>
                                <!-- div class="field">
                                    <label class="checkbox">
                                        <input type="checkbox">
                                        Remember me
                                    </label>
                                </div -->
                                <button v-if="!signUp" @click="pw" :class="{ 'is-loading': loading }" class="button is-block is-info is-medium is-fullwidth raised is-clear">Login</button>
                                <button v-else @click="createUser" :class="{ 'is-loading': loading }" class="button is-block is-info is-medium is-fullwidth raised is-clear">Sign Up</button>
                            <hr>
                                <div class="field">
                                  <div class="control has-icons-left">
                                    <input class="input is-medium" type="text" placeholder="Text input" :class="{ 'is-danger': empty }" v-model="name">
                                    <span class="icon is-small is-left">
                                      <i class="fa fa-user"></i>
                                    </span>
                                  </div>
                                </div>
                                <button @click="anon" :class="{ 'is-loading': loading }" class="button is-block is-warning is-medium is-fullwidth raised is-clear">Anonymous login</button>
                        </div>
                        <p class="has-text-grey">
                            <a v-if="!signUp" @click="signUpMode">Sign up</a>
                            <a v-else @click="signUpMode">Log in</a> &nbsp;·&nbsp;
                            <a href="">Forgot Password</a> &nbsp;·&nbsp;
                            <a @click="help">Need Help?</a>
                        </p>
                    </div>
                </div>
            </div>
        </section>
    </div>
</template>

<script>
import { auth , DB } from '@/plugins/firebase.js';

export default {
  data: function () {
    return {
        email: 'edwin.guo1@gmail.com',
        password: 'test123',
        cpassword: 'test123',
        loading: false,
        signUp: false,
        name: ''
    }
  },
  computed: {
    signlogin: function () {
        if (this.signUp) {
            return 'Sign Up'
        }
        else {
            return 'Log In'
        }
    },
    mismatch: function () {
        if (this.password != this.cpassword && this.password != '' && this.cpassword != '') {
            return true
        }
        else {
            return false
        }
    },
    empty: function () {
        if (this.name == '') {
            return true
        }
        else {
            return false
        }
    }
  },
  methods: {
    signUpMode: function () {
        if (this.signUp == true) {
            this.signUp = false
        }
        else {
            this.signUp = true
        }
    },
    async fetchNickname() {
    //fetchNickname: function() {
        
        const name = await this.$axios.$post('https://api.codetunnel.net/random-nick', {})
        if (name.success == true) {
            this.name = name.nickname
        }
        
        return Promise.resolve(name.nickname) 
        
        /*
        const name = generate().spaced; // 'grandiose clam'
        
        return name
        */
        
    },
    createUser: function () {
        self = this
        let email = this.email 
        let password = this.password
        let cpassword = this.cpassword 
        //let nickname = this.fetchNickname()
        var nickname = this.name
        
        if (cpassword == password) {
            self.loading = true
            auth.createUserWithEmailAndPassword(email, password)
            .then(function(result) {
                console.log(result.user)
                var user = {
                    uid: result.user.uid,
                    anon: result.user.isAnonymous,
                    name: nickname
                }
                DB.ref('users/' + user.uid).set(user)
                .then(function() {
                    self.$store.dispatch('signin', user)
                })
                .catch(error => {
                // Handle Errors here.
                    console.log(error.message)
                    self.loading = false
                    self.$izitoast.error({
                        title: 'Uh-oh',
                        message: error.message
                    })
                });  
            })
            .then(function() {
                self.loading = false
                self.$izitoast.success({
                    title: 'Hooray',
                    message: "I'm signed up!"
                })
                self.$router.push('/topics')
            })
            .catch(error => {
            // Handle Errors here.
                console.log(error.message)
                self.loading = false
                self.$izitoast.error({
                    title: 'Uh-oh',
                    message: error.message
                })
            //var errorCode = error.code;
            //var errorMessage = error.message;
            // ...
            });    
        }
        else {
            this.$izitoast.error({
                title: 'Uh-oh',
                message: 'passwords do not match'
            })
        }
    },
    async anon () {
        this.loading = true
        //let nickname = await this.fetchNickname()
        let nickname = this.name
        self = this
        var verify = true

        if (this.name != '') 
        {
            verify = false
            auth.signInAnonymously()
            .then(function(result) {
                var user = {
                    uid: result.user.uid,
                    anon: result.user.isAnonymous,
                    name: nickname
                }
                console.log(user)
                self.$store.dispatch('signin', user)
                .then(function() {
                    self.loading = false
                    self.$izitoast.success({
                        title: 'Hooray',
                        message: "I'm anonymous!"
                    }) 
                    self.$router.push('/topics')
                })
            })
            .catch(error => {
            // Handle Errors here.
                console.log(error.message)
                self.loading = false
                self.$izitoast.error({
                    title: 'Uh-oh',
                    message: error.message
                })
            });  

        }
    },
    async pw () {
        this.loading = true
        //let nickname = await this.fetchNickname()
        let nickname = this.name
        self = this
        auth.signInWithEmailAndPassword(this.email, this.password)
        .then(function(result) {
            
            DB.ref('users/' + result.user.uid).once('value')
            .then(function(snapshot) {
                var user = snapshot.val()
                console.log(snapshot.val())
                self.$store.dispatch('signin', user)
                self.loading = false
                self.$izitoast.success({
                    title: 'Hooray',
                    message: 'I signed in!'
                })
                self.$router.push('/topics')
            })
            .catch(error => {
                console.log(error.message)
                self.loading = false
                self.$izitoast.error({
                    title: 'Uh-oh',
                    message: error.message
                })
            })

        })
        .catch(error => {
        // Handle Errors here.
            console.log(error.message)
            self.loading = false
            self.$izitoast.error({
                title: 'Uh-oh',
                message: error.message
            })
        });  
    },
    help: function () {
        this.$izitoast.info({
            title: 'Nah',
            message: "You don't need help!"
        })
    }
  },
  mounted(){
    this.fetchNickname()
  }
}
</script>

